package com.unis.lawEnforcementSupervision.config;

import com.github.xiaoymin.knife4j.spring.extension.OpenApiExtensionResolver;
import com.unis.common.pojo.CommonResult;
import io.swagger.annotations.ApiOperation;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.bind.annotation.RequestMethod;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.Contact;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;

import javax.annotation.Resource;

/**
 * @author qingsong.han
 * @description:
 * @create 2024-06-22 14:17
 */
@Configuration
public class LawEnforcementSupervisionConfigure {
    @Resource
    private OpenApiExtensionResolver openApiExtensionResolver;

    /**
     * API文档分组配置
     *
     * @author qingsong.han
     * @date 2024-06-22 14:17
     **/
    @Bean(value = "lawEnforcementSupervisionDocApi")
    public Docket lawEnforcementSupervisionDocApi() {
        return new Docket(DocumentationType.SWAGGER_2)
                .apiInfo(new ApiInfoBuilder()
                        .title("执法监督(监督检查处)")
                        .description("执法监督(监督检查处)")
                        .termsOfServiceUrl("https://www.xiaonuo.vip")
                        .contact(new Contact("UNIS_TEAM", "https://www.xiaonuo.vip", "xuyuxiang29@foxmail.com"))
                        .version("2.18.0")
                        .build())
                .globalResponseMessage(RequestMethod.GET, CommonResult.responseList())
                .globalResponseMessage(RequestMethod.POST, CommonResult.responseList())
                .groupName("执法监督(监督检查处)")
                .select()
                .apis(RequestHandlerSelectors.withMethodAnnotation(ApiOperation.class))
                .apis(RequestHandlerSelectors.basePackage("com.unis.lawEnforcementSupervision"))
                .paths(PathSelectors.any())
                .build().extensions(openApiExtensionResolver.buildExtensions("执法监督(监督检查处)"));
    }
}
